# Python imports
from uuid import uuid4

# Third-party imports
from neomodel import StructuredNode, StringProperty, IntegerProperty, UniqueIdProperty, RelationshipTo

class GPhLPipedream(StructuredNode):
	
	"""
	Defines node properties and relationships
	Provides data serializer
	"""
	
	# Properties
	command=StringProperty()
	jsonversion=StringProperty()
	runby=StringProperty()
	runfrom=StringProperty()
	jobid=StringProperty(unique_index=True, default=uuid4)
	output=StringProperty()
	version=StringProperty()

	@property
	def serialize(self):

		"""
		Serializer for node properties
		"""
		
		return {
		'GPhL_pipedream_node_properties': {
		'command': self.command,
		'jsonversion': self.jsonversion,
		'runby': self.runby,
		'runfrom': self.runfrom,
		'jobid': self.uuid,
		'output': self.output,
		'version': self.version,
		},
		}